## emscripten 2.0.13~dfsg

=== debian/changelog ===
emscripten (2.0.13~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * copyright:
    + update list of repackaging-excluded files
    + update coverage
  * update source-only part of upstream source-map script
  * unfuzz patches
  * use debhelper compatibility level 13 (not 12)
  * update documentation source path
  * fix really tighten build-dependency on binaryen
    (not only runtime dependency),
    as intended since 2.0.10~dfsg-1

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 18 Jul 2021 21:12:38 +0200

=== debian/control ===
Source: emscripten
Section: devel
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 binaryen (>= 99) <!nocheck>,
 clang (>= 1:11.0) <!nocheck>,
 cmake <!nocheck>,
 eslint <!nocheck>,
 fonts-liberation <!nocheck>,
 libsimde-dev,
 lld (>= 1:11.0) <!nocheck>,
 llvm (>= 1:11.0) <!nocheck>,
 debhelper-compat (= 13),
 dh-sequence-python3,
 help2man,
 htmlmin <!nocheck>,
 libjs-source-map,
 node-acorn <!nocheck>,
 nodejs <!nocheck>,
 python3,
 python3-numpy <!nocheck>,
 python3-ply <!nocheck>,
 scons <!nocheck>,
 wabt <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nocheck>,
 python3-sphinx <!nodoc>,
Standards-Version: 4.5.1
Homepage: http://emscripten.org/
Vcs-Browser: https://salsa.debian.org/js-team/emscripten
Vcs-Git: https://salsa.debian.org/js-team/emscripten.git
Rules-Requires-Root: no

Package: emscripten
Architecture: all
Depends:
 binaryen (>= 99),
 clang (>= 1:11.0),
 lld (>= 1:11.0),
 llvm (>= 1:11.0),
 node-acorn,
 nodejs,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 libjs-d3,
 python3-numpy,
Suggests:
 adb,
 automake,
 closure-compiler,
 cmake,
 make,
 python3-ply,
 scons,
 wabt,
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 Some uses of emscripten require additional packages:
  * setting WASM2C requires wabt.
  * emcmake requires cmake.
  * emconfigure may require automake.
  * emmake requires make.
  * emrun option --android requires adb.
  * emscons requires scons.
  * WebIDL Binder requires python3-ply.

Package: emscripten-doc
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Architecture: all
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
-include /usr/share/dpkg/buildopts.mk

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

DEB_VERSION_UPSTREAM_ORIG = $(firstword $(subst ~,$() ,$(DEB_VERSION_UPSTREAM)))

ifneq (,$(DEB_BUILD_OPTION_PARALLEL))
export EMCC_CORES=$(DEB_BUILD_OPTION_PARALLEL)
endif

EM_OPTS = PATH="$(CURDIR):$$PATH" EM_CACHE="$(CURDIR)/debian/em_cache"
EMCC = $(EM_OPTS) emcc
TESTS_RUNNER = $(EM_OPTS) EMTEST_SKIP_SLOW=1 EMTEST_LACKS_CLOSURE_COMPILER=1 tests/runner.py
# use ccache when available
ifneq (,$(wildcard /usr/bin/ccache))
override_dh_auto_test: export EM_COMPILER_WRAPPER=ccache
endif

# files generated during build
SOURCE_MAP_MIN_JS = src/emscripten-source-map.min.js
NEON_H = system/include/compat/arm_neon.h

# requires third-party tests and EH functions renaming bugfix (see bug#975069)
#  * test_freetype also requires symlinked LiberationSansBold.ttf
#  * test_poppler also requires tests.poppler.paper.pdf
ERRORS_wasm += \
 test_freetype \
 test_lua \
 test_poppler

# requires Emscripten Ports
ERRORS_other += \
 test_bullet \
 test_bullet_autoconf \
 test_bullet_cmake \
 test_bzip2 \
 test_freetype \
 test_libjpeg \
 test_libpng \
 test_sdl2_mixer_wav \
 test_vorbis
FAILS_CERTAIN_other += \
 test_boost_graph

# requires bugfix for LinkError: WebAssembly.instantiate():
# Import #151 module="env" function="__stack_pointer" error:
# imported global does not match the expected mutability
FAILS_wasm += \
 test_dlfcn_alignment_and_zeroing \
 test_dlfcn_basic \
 test_dlfcn_data_and_fptr \
 test_dlfcn_funcs \
 test_dlfcn_handle_alloc \
 test_dlfcn_i64 \
 test_dlfcn_info \
 test_dlfcn_longjmp \
 test_dlfcn_mallocs \
 test_dlfcn_missing \
 test_dlfcn_qsort \
 test_dlfcn_self \
 test_dlfcn_stacks \
 test_dlfcn_unique_sig \
 test_dlfcn_varargs \
 test_dylink_basics \
 test_dylink_class \
 test_dylink_dot_a \
 test_dylink_dso_needed \
 test_dylink_dynamic_cast \
 test_dylink_floats \
 test_dylink_funcpointer \
 test_dylink_funcpointers_wrapper \
 test_dylink_function_pointer_equality \
 test_dylink_global_init \
 test_dylink_global_inits \
 test_dylink_global_var \
 test_dylink_global_var_modded \
 test_dylink_i64 \
 test_dylink_i64_b \
 test_dylink_i64_c \
 test_dylink_iostream \
 test_dylink_jslib \
 test_dylink_many_postsets \
 test_dylink_memory_growth \
 test_dylink_no_export \
 test_dylink_postsets_chunking \
 test_dylink_printfs \
 test_dylink_rtti \
 test_dylink_safe_heap \
 test_dylink_spaghetti \
 test_dylink_static_funcpointer_float \
 test_dylink_static_funcpointers \
 test_dylink_stdlib \
 test_dylink_zlib \
 test_em_js_linked \
 test_main_module_static_align \
 test_relocatable_void_function \
 test_safe_stack_dylink \
 test_stack_placement_pic
ERRORS_other += \
 test_bad_function_pointer_cast \
 test_binaryen_ctors \
 test_dlopen_rtld_global \
 test_dlsym_rtld_default \
 test_export_aliasee \
 test_ld_library_path \
 test_main_module_without_exceptions_message \
 test_main_module_without_main \
 test_minimal_dynamic

# requires EH functions renaming bugfix (see bug#975069)
FAILS_wasm += \
 test_*_eh \
 test_bad_typeid \
 test_dylink_i64_invoke \
 test_dylink_raii_exceptions \
 test_exceptions \
 test_exceptions_2 \
 test_exceptions_3 \
 test_exceptions_alias \
 test_exceptions_allowed \
 test_exceptions_allowed_2 \
 test_exceptions_allowed_uncaught \
 test_exceptions_convert \
 test_exceptions_custom \
 test_exceptions_destroy_virtual \
 test_exceptions_libcxx \
 test_exceptions_minimal_runtime \
 test_exceptions_multi \
 test_exceptions_multiple_inherit \
 test_exceptions_multiple_inherit_rethrow \
 test_exceptions_primary \
 test_exceptions_resume \
 test_exceptions_rethrow \
 test_exceptions_simplify_cfg \
 test_exceptions_std \
 test_exceptions_typed \
 test_exceptions_uncaught_2 \
 test_exceptions_uncaught \
 test_exceptions_uncaught_count \
 test_exceptions_virtual_inheritance
FAILS_wasm0 += \
 test_exceptions_refcount
FAILS_other += \
 test_locale_wrong \
 test_metadce_cxx_except \
 test_metadce_cxx_mangle \
 test_no_legalize_js_ffi \
 test_only_force_stdlibs_2 \
 test_wasm_backend_lto_libcxx_noexcept

# requires bugfix for AssertionError:
# JS subprocess failed (/usr/bin/nodejs src.js): 7.  Output:
# Assertion failed: failure to getMemory
FAILS_wasm0 += \
 test_dylink_basics_no_modify

# requires bugfix for AssertionError:
# JS subprocess failed (/usr/bin/nodejs test_nodefs_home.js): 1.  Output:
# exception thrown: Error: No such file or directory,Error
FAILS_wasm += \
 test_fs_nodefs_home

# requires bugfix for error: undefined symbol: ...
FAILS_wasm += \
 test_i64_invoke_bigint \
 test_longjmp \
 test_longjmp2 \
 test_longjmp2_main_module \
 test_longjmp3 \
 test_longjmp4 \
 test_longjmp_exc \
 test_longjmp_funcptr \
 test_longjmp_i64 \
 test_longjmp_repeat \
 test_longjmp_stacked \
 test_longjmp_throw \
 test_longjmp_unwind \
 test_pthread_exceptions \
 test_setjmp_many \
 test_setjmp_many_2 \
 test_setjmp_noleak \
 test_siglongjmp
FAILS_other += \
 test_exception_settings \
 test_f_exception \
 test_fignore_exceptions

# requires bugfix for FileNotFoundError:
# [Errno 2] No such file or directory: 'emcc'
FAILS_other += \
 test_scons

# requires bugfix for FileNotFoundError:
# [Errno 2] No such file or directory: '/usr/share/emscripten/emcmake'
FAILS_other += \
 test_cmake_stdproperty

# requires bugfix for AssertionError: Unexpected difference: ...
FAILS_other += \
 test_metadce_hello_main_module_2

# requires bugfix for AssertionError: subprocess exited with non-zero return code(1):
# `emcc /usr/share/emscripten/tests/hello_world.cpp -Wl,--no-check-features,-mllvm,-debug`
#  * wasm-ld (LLVM option parsing): Unknown command line argument '-debug'
FAILS_other += \
 test_supported_linker_flags

# requires bugfix for AssertionError: subprocess exited with non-zero return code(1):
# `emcc -nostdlib++ /<<PKGBUILDDIR>>/tests/other/test_split_main_module.c
# -o test_split_main_module.js -Werror
# -g -sMAIN_MODULE=2 -sEXPORTED_FUNCTIONS=[_printf] -sSPLIT_MODULE=1
# -Wno-experimental --embed-file libhello.wasm
# --post-js /<<PKGBUILDDIR>>/tests/other/test_split_module.post.js
# -sINITIAL_TABLE=16
# -I. -I/<<PKGBUILDDIR>>/tests/other -I/<<PKGBUILDDIR>>/tests/other/include`
FAILS_other += \
 test_split_main_module

# avoid unimportant mode causing multiple failures: strict
CHECK_MODES_WASMX = wasm0 wasm1 wasm2 wasm3 wasms wasmz
CHECK_MODES_WASMJS = wasm2js1 wasm2js2 wasm2js3 wasm2jss wasm2jsz

# maybe requires setting EMSCRIPTEN_TOOLPATH
FAILS_other += \
 test_emscons

# requires bugfix for TypeError:
# Cannot read property 'toString' of undefined
FAILS_other += \
 test_dlopen_bad_flags \
 test_dlsym_rtld_default_js_symbol

# expects smaller output
FAILS_wasm1 += \
 test_emscripten_lazy_load_code_unconditional
FAILS_other += \
 test_function_exports_are_small \
 test_js_function_names_are_minified \
 test_minimal_runtime_code_size_*

# needs node module wasm2c
FAILS_wasmX_wasm2c += \
 test_autodebug_wasm_standalone \
 test_cube2hash_standalone \
 test_longjmp_standalone \
 test_posixtime_standalone
FAILS_other += \
 test_wasm2c_reactor \

NONSCRIPT_EXECUTABLE = \
 system/lib/libcxx/readme.txt \
 tests/other/wasm_sourcemap/foo.wasm \
 tests/other/wasm_sourcemap_dead/t.wasm \
 tools/system_libs.py

SCRIPT_NOT_EXECUTABLE = \
 src/compiler.js \
 tests/embind/build_benchmark \
 third_party/uglify-js/test/beautify.js \
 third_party/uglify-js/test/testparser.js \
 third_party/uglify-js/tmp/test.js \
 tools/js-optimizer.js \
 tools/preprocessor.js \
 tools/source-maps/sourcemap2json.js \
 tools/source-maps/sourcemapper.js

%:
	dh $@

# refresh upstream version hints from Debian package
override_dh_auto_configure: $(SOURCE_MAP_MIN_JS) $(NEON_H)
	cp -f emscripten-version.txt emscripten-version.txt.orig
	echo $(DEB_VERSION_UPSTREAM_ORIG) > emscripten-version.txt
	echo $(patsubst $(DEB_VERSION_UPSTREAM_ORIG)-%,%,$(DEB_VERSION_UPSTREAM_ORIG_REVISION)) \

## emscripten 3.1.5~dfsg

=== tests/cmake/cmake_with_emval/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(cmake_with_emval)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (NO_GNU_EXTENSIONS)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

add_executable(cmake_with_emval main.cpp)

=== tests/cmake/target_html/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(hello_world_gles)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../cpp_lib ${CMAKE_CURRENT_BINARY_DIR}/cpp_lib)

file(GLOB sourceFiles ../../hello_world_gles.c)

if (CMAKE_BUILD_TYPE STREQUAL Debug)
  set(linkFlags "")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
  set(linkFlags "-O2")
endif()

if (NOT CMAKE_AR OR NOT EXISTS "${CMAKE_AR}")
  message(FATAL_ERROR "CMAKE_AR='${CMAKE_AR}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_RANLIB OR NOT EXISTS "${CMAKE_RANLIB}")
  message(FATAL_ERROR "CMAKE_RANLIB='${CMAKE_RANLIB}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_C_COMPILER OR NOT EXISTS "${CMAKE_C_COMPILER}")
  message(FATAL_ERROR "CMAKE_C_COMPILER='${CMAKE_C_COMPILER}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_CXX_COMPILER OR NOT EXISTS "${CMAKE_CXX_COMPILER}")
  message(FATAL_ERROR "CMAKE_CXX_COMPILER='${CMAKE_CXX_COMPILER}' does not exist for Emscripten toolchain!")
endif()

if (WIN32)
  message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
  message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
  message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
  message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

# with NO_DEFAULT_PATH + ONLY_CMAKE_FIND_ROOT_PATH, we ensure that
# only ${CMAKE_FIND_ROOT_PATH}/include will be searched for
# emscripten/emscripten.h
find_path(EMSCRIPTEN_INCLUDE_DIR emscripten/emscripten.h
  PATHS /include
  NO_DEFAULT_PATH
  ONLY_CMAKE_FIND_ROOT_PATH
)

if(NOT EMSCRIPTEN_INCLUDE_DIR)
  message(FATAL_ERROR "emscripten.h could not be found! Is CMAKE_FIND_ROOT_PATH='${CMAKE_FIND_ROOT_PATH}' correct?")
endif()

include(CheckIncludeFile)

check_include_file(stdlib.h HAVE_STDLIB_H)
if (NOT HAVE_STDLIB_H)
  message(FATAL_ERROR "CMake script check_include_file failed! Could not find stdlib.h via it!")
endif()

# Artificially make up a long command line. This tests that long command lines work when passed to check_include_file().
# This fails on Windows with CMake 3.2.0 with mingw32-make (GNU make 4.0) and older. Upgrade to CMake 3.3.1 to fix.
set(CMAKE_C_FLAGS "-fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char")

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
if (NOT HAVE_SYS_TYPES_H)
  message(FATAL_ERROR "CMake script check_include_file failed! Could not find sys/types.h via it!")
endif()

if (NOT CMAKE_EXECUTABLE_SUFFIX STREQUAL ".js")
  message(FATAL_ERROR "The default suffix for building executables should be .js!")
endif()
set(CMAKE_EXECUTABLE_SUFFIX ".html")

# CMake built-in check_include_file() macro interacts with CMAKE_EXECUTABLE_SUFFIX, so make sure it works after user changes that.

check_include_file(math.h HAVE_MATH_H)
if (NOT HAVE_MATH_H)
  message(FATAL_ERROR "CMake script check_include_file failed! Could not find math.h via it!")
endif()

add_executable(hello_world_gles ${sourceFiles})
target_link_libraries(hello_world_gles cpp_lib)
set_target_properties(hello_world_gles PROPERTIES LINK_FLAGS "${linkFlags}")

=== tests/third_party/box2d/Makefile ===
# Makefile for generating a Box2D library using Emscripten.

O = Box2D
OBJECTS = \
  $(O)/Collision/b2BroadPhase.o \
  $(O)/Collision/b2CollideCircle.o \
  $(O)/Collision/b2CollideEdge.o \
  $(O)/Collision/b2CollidePolygon.o \
  $(O)/Collision/b2Collision.o \
  $(O)/Collision/b2Distance.o \
  $(O)/Collision/b2DynamicTree.o \
  $(O)/Collision/b2TimeOfImpact.o \
  $(O)/Collision/Shapes/b2ChainShape.o \
  $(O)/Collision/Shapes/b2CircleShape.o \
  $(O)/Collision/Shapes/b2EdgeShape.o \
  $(O)/Collision/Shapes/b2PolygonShape.o \
  $(O)/Common/b2BlockAllocator.o \
  $(O)/Common/b2Draw.o \
  $(O)/Common/b2Math.o \
  $(O)/Common/b2Settings.o \
  $(O)/Common/b2StackAllocator.o \
  $(O)/Common/b2Timer.o \
  $(O)/Dynamics/b2Body.o \
  $(O)/Dynamics/b2ContactManager.o \
  $(O)/Dynamics/b2Fixture.o \
  $(O)/Dynamics/b2Island.o \
  $(O)/Dynamics/b2World.o \
  $(O)/Dynamics/b2WorldCallbacks.o \
  $(O)/Dynamics/Contacts/b2ChainAndCircleContact.o \
  $(O)/Dynamics/Contacts/b2ChainAndPolygonContact.o \
  $(O)/Dynamics/Contacts/b2CircleContact.o \
  $(O)/Dynamics/Contacts/b2Contact.o \
  $(O)/Dynamics/Contacts/b2ContactSolver.o \
  $(O)/Dynamics/Contacts/b2EdgeAndCircleContact.o \
  $(O)/Dynamics/Contacts/b2EdgeAndPolygonContact.o \
  $(O)/Dynamics/Contacts/b2PolygonAndCircleContact.o \
  $(O)/Dynamics/Contacts/b2PolygonContact.o \
  $(O)/Dynamics/Joints/b2DistanceJoint.o \
  $(O)/Dynamics/Joints/b2FrictionJoint.o \
  $(O)/Dynamics/Joints/b2GearJoint.o \
  $(O)/Dynamics/Joints/b2Joint.o \
  $(O)/Dynamics/Joints/b2MouseJoint.o \
  $(O)/Dynamics/Joints/b2PrismaticJoint.o \
  $(O)/Dynamics/Joints/b2PulleyJoint.o \
  $(O)/Dynamics/Joints/b2RevoluteJoint.o \
  $(O)/Dynamics/Joints/b2RopeJoint.o \
  $(O)/Dynamics/Joints/b2WeldJoint.o \
  $(O)/Dynamics/Joints/b2WheelJoint.o \
  $(O)/Rope/b2Rope.o

all: box2d.a

%.o: %.cpp
	$(CXX) $(CFLAGS) -I. $< -o $@ -O2 -c -fno-exceptions -fno-rtti -Wno-null-conversion

box2d.a: $(OBJECTS)
	$(AR) rvs $@ $(OBJECTS)

clean:
	rm box2d.a

=== tests/third_party/glbook/Makefile ===
# Straight forward Makefile to compile all examples in a row

INCDIR=-I./Common
LIBS=-lGLESv2 -lEGL -lm -lX11

COMMONSRC=Common/esShader.c    \
          Common/esTransform.c \
          Common/esShapes.c    \
          Common/esUtil.c
COMMONHRD=esUtil.h

CH02SRC=Chapter_2/Hello_Triangle/Hello_Triangle.c
CH08SRC=Chapter_8/Simple_VertexShader/Simple_VertexShader.c
CH09SRC1=Chapter_9/Simple_Texture2D/Simple_Texture2D.c
CH09SRC2=Chapter_9/MipMap2D/MipMap2D.c
CH09SRC3=Chapter_9/Simple_TextureCubemap/Simple_TextureCubemap.c
CH09SRC4=Chapter_9/TextureWrap/TextureWrap.c
CH10SRC=Chapter_10/MultiTexture/MultiTexture.c
CH11SRC=Chapter_11/Multisample/Multisample.c
CH11SRC2=Chapter_11/Stencil_Test/Stencil_Test.c
CH13SRC2=Chapter_13/ParticleSystem/ParticleSystem.c

default: all

all: Chapter_2/Hello_Triangle/CH02_HelloTriangle.o \
     Chapter_8/Simple_VertexShader/CH08_SimpleVertexShader.o \
     Chapter_9/Simple_Texture2D/CH09_SimpleTexture2D.o \
     Chapter_9/MipMap2D/CH09_MipMap2D.o \
     Chapter_9/Simple_TextureCubemap/CH09_TextureCubemap.o \
     Chapter_9/TextureWrap/CH09_TextureWrap.o \
     Chapter_10/MultiTexture/CH10_MultiTexture.o \
     Chapter_13/ParticleSystem/CH13_ParticleSystem.o
#     Chapter_11/Multisample/CH11_Multisample.o \
#     Chapter_11/Stencil_Test/CH11_Stencil_Test.o \

clean:
	find . -name "CH??_*" | xargs rm -f

Chapter_2/Hello_Triangle/CH02_HelloTriangle.o: ${COMMONSRC} ${COMMONHDR} ${CH02SRC}
	$(CC) ${COMMONSRC} ${CH02SRC} -r -o $@ ${INCDIR} ${LIBS}
Chapter_8/Simple_VertexShader/CH08_SimpleVertexShader.o: ${COMMONSRC} ${COMMONHDR} ${CH08SRC}
	$(CC) ${COMMONSRC} ${CH08SRC} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_9/Simple_Texture2D/CH09_SimpleTexture2D.o: ${COMMONSRC} ${COMMONHDR} ${CH09SRC1}
	$(CC) ${COMMONSRC} ${CH09SRC1} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_9/MipMap2D/CH09_MipMap2D.o: ${COMMONSRC} ${COMMONHDR} ${CH09SRC2}
	$(CC) ${COMMONSRC} ${CH09SRC2} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_9/Simple_TextureCubemap/CH09_TextureCubemap.o: ${COMMONSRC} ${COMMONHDR} ${CH09SRC3}
	$(CC) ${COMMONSRC} ${CH09SRC3} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_9/TextureWrap/CH09_TextureWrap.o: ${COMMONSRC} ${COMMONHDR} ${CH09SRC4}
	$(CC) ${COMMONSRC} ${CH09SRC4} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_10/MultiTexture/CH10_MultiTexture.o: ${COMMONSRC} ${COMMONHDR} ${CH10SRC}
	$(CC) ${COMMONSRC} ${CH10SRC} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_11/Multisample/CH11_Multisample.o: ${COMMONSRC} ${COMMONHDR} ${CH11SRC}
	$(CC) ${COMMONSRC} ${CH11SRC} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_11/Stencil_Test/CH11_Stencil_Test.o: ${COMMONSRC} ${COMMONHDR} ${CH11SRC2}
	$(CC) ${COMMONSRC} ${CH11SRC2} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_13/Noise3D/CH13_Noise3D.o: ${COMMONSRC} ${COMMONHDR} ${CH13SRC1}
	$(CC) ${COMMONSRC} ${CH13SRC1} -r -o ./$@ ${INCDIR} ${LIBS}
Chapter_13/ParticleSystem/CH13_ParticleSystem.o: ${COMMONSRC} ${COMMONHDR} ${CH13SRC2}
	$(CC) ${COMMONSRC} ${CH13SRC2} -r -o ./$@ ${INCDIR} ${LIBS}

=== system/lib/libunwind/src/CMakeLists.txt ===
# Get sources

set(LIBUNWIND_CXX_SOURCES
    libunwind.cpp
    Unwind-EHABI.cpp
    Unwind-seh.cpp
    )
if(APPLE)
  list(APPEND LIBUNWIND_CXX_SOURCES
    Unwind_AppleExtras.cpp
    )
endif()

set(LIBUNWIND_C_SOURCES
    UnwindLevel1.c
    UnwindLevel1-gcc-ext.c
    Unwind-sjlj.c
    )
set_source_files_properties(${LIBUNWIND_C_SOURCES}
                            PROPERTIES
                              COMPILE_FLAGS "-std=c99")

set(LIBUNWIND_ASM_SOURCES
    UnwindRegistersRestore.S
    UnwindRegistersSave.S
    )
if (MINGW OR APPLE)
  # CMake doesn't build assembly sources for windows/gnu targets properly
  # (up to current CMake, 3.16), so treat them as C files.
  # Additionally, CMake ignores OSX_ARCHITECTURE for ASM files when targeting
  # Apple platforms.
  set_source_files_properties(${LIBUNWIND_ASM_SOURCES}
                              PROPERTIES
                                LANGUAGE C)
endif()

set(LIBUNWIND_HEADERS
    AddressSpace.hpp
    assembly.h
    CompactUnwinder.hpp
    config.h
    dwarf2.h
    DwarfInstructions.hpp
    DwarfParser.hpp
    libunwind_ext.h
    Registers.hpp
    RWMutex.hpp
    UnwindCursor.hpp
    ../include/libunwind.h
    ../include/unwind.h
    )
if(APPLE)
  list(APPEND LIBUNWIND_HEADERS
    ../include/mach-o/compact_unwind_encoding.h
    )
endif()

if (MSVC_IDE)
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  source_group("Header Files" FILES ${LIBUNWIND_HEADERS})
endif()

set(LIBUNWIND_SOURCES
    ${LIBUNWIND_CXX_SOURCES}
    ${LIBUNWIND_C_SOURCES}
    ${LIBUNWIND_ASM_SOURCES})

# Generate library list.
add_library_flags_if(LIBUNWIND_HAS_C_LIB c)
if (LIBUNWIND_USE_COMPILER_RT)
  add_library_flags("${LIBUNWIND_BUILTINS_LIBRARY}")
else()
  add_library_flags_if(LIBUNWIND_HAS_GCC_S_LIB gcc_s)
  add_library_flags_if(LIBUNWIND_HAS_GCC_LIB gcc)
endif()
add_library_flags_if(LIBUNWIND_HAS_DL_LIB dl)
if (LIBUNWIND_ENABLE_THREADS)
  add_library_flags_if(LIBUNWIND_HAS_PTHREAD_LIB pthread)
  add_compile_flags_if(LIBUNWIND_WEAK_PTHREAD_LIB -DLIBUNWIND_USE_WEAK_PTHREAD=1)
endif()

# Setup flags.
add_link_flags_if_supported(-nodefaultlibs)

# MINGW_LIBRARIES is defined in config-ix.cmake
add_library_flags_if(MINGW "${MINGW_LIBRARIES}")

if (LIBUNWIND_ENABLE_SHARED AND
    NOT (LIBUNWIND_SUPPORTS_FNO_EXCEPTIONS_FLAG AND
         LIBUNWIND_SUPPORTS_FUNWIND_TABLES_FLAG))
  message(FATAL_ERROR
          "Compiler doesn't support generation of unwind tables if exception "
          "support is disabled.  Building libunwind DSO with runtime dependency "
          "on C++ ABI library is not supported.")
endif()

if (APPLE)
  add_compile_flags("-U__STRICT_ANSI__")
  add_link_flags("-compatibility_version 1" "-install_name /usr/lib/libunwind.1.dylib")

  if (CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "10.6")
    add_link_flags("-current_version ${LIBUNWIND_VERSION}" "/usr/lib/libSystem.B.dylib")
  endif ()
endif ()

string(REPLACE ";" " " LIBUNWIND_COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_CXX_FLAGS "${LIBUNWIND_CXX_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_C_FLAGS "${LIBUNWIND_C_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}")

set_property(SOURCE ${LIBUNWIND_CXX_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS " ${LIBUNWIND_CXX_FLAGS}")
set_property(SOURCE ${LIBUNWIND_C_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS " ${LIBUNWIND_C_FLAGS}")

# NOTE: avoid implicit dependencies on C++ runtimes.  libunwind uses C++ for
# ease, but does not rely on C++ at runtime.
set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")

# Build the shared library.
if (LIBUNWIND_ENABLE_SHARED)
  add_library(unwind_shared SHARED ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
  if(CMAKE_C_COMPILER_ID STREQUAL MSVC)
    target_compile_options(unwind_shared PRIVATE /GR-)
  else()
    target_compile_options(unwind_shared PRIVATE -fno-rtti)
  endif()
  if(COMMAND llvm_setup_rpath)
    llvm_setup_rpath(unwind_shared)
  endif()
  target_link_libraries(unwind_shared PRIVATE ${LIBUNWIND_LIBRARIES})
  set_target_properties(unwind_shared PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}"
    LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}"
    LINKER_LANGUAGE C
    OUTPUT_NAME "unwind"
    VERSION "1.0"
    SOVERSION "1")
  list(APPEND LIBUNWIND_BUILD_TARGETS "unwind_shared")
  if (LIBUNWIND_INSTALL_SHARED_LIBRARY)
    list(APPEND LIBUNWIND_INSTALL_TARGETS "unwind_shared")
  endif()
endif()

# Build the static library.
if (LIBUNWIND_ENABLE_STATIC)
  add_library(unwind_static STATIC ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
  if(CMAKE_C_COMPILER_ID STREQUAL MSVC)
    target_compile_options(unwind_static PRIVATE /GR-)
  else()
    target_compile_options(unwind_static PRIVATE -fno-rtti)
  endif()
  target_link_libraries(unwind_static PRIVATE ${LIBUNWIND_LIBRARIES})
  set_target_properties(unwind_static PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}"
    LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}"
    LINKER_LANGUAGE C
    OUTPUT_NAME "unwind")

  if(LIBUNWIND_HERMETIC_STATIC_LIBRARY)
    append_flags_if_supported(UNWIND_STATIC_LIBRARY_FLAGS -fvisibility=hidden)
    append_flags_if_supported(UNWIND_STATIC_LIBRARY_FLAGS -fvisibility-global-new-delete-hidden)
    target_compile_options(unwind_static PRIVATE ${UNWIND_STATIC_LIBRARY_FLAGS})
    target_compile_definitions(unwind_static PRIVATE _LIBUNWIND_DISABLE_VISIBILITY_ANNOTATIONS)
  endif()

  list(APPEND LIBUNWIND_BUILD_TARGETS "unwind_static")
  if (LIBUNWIND_INSTALL_STATIC_LIBRARY)
    list(APPEND LIBUNWIND_INSTALL_TARGETS "unwind_static")
  endif()
endif()

# Add a meta-target for both libraries.
add_custom_target(unwind DEPENDS ${LIBUNWIND_BUILD_TARGETS})

if (LIBUNWIND_INSTALL_LIBRARY)
  install(TARGETS ${LIBUNWIND_INSTALL_TARGETS}
    LIBRARY DESTINATION ${LIBUNWIND_INSTALL_PREFIX}${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    ARCHIVE DESTINATION ${LIBUNWIND_INSTALL_PREFIX}${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind)
endif()

if (NOT CMAKE_CONFIGURATION_TYPES AND LIBUNWIND_INSTALL_LIBRARY)
  add_custom_target(install-unwind
    DEPENDS unwind
    COMMAND "${CMAKE_COMMAND}"
            -DCMAKE_INSTALL_COMPONENT=unwind
            -P "${LIBUNWIND_BINARY_DIR}/cmake_install.cmake")
  add_custom_target(install-unwind-stripped
    DEPENDS unwind
    COMMAND "${CMAKE_COMMAND}"
            -DCMAKE_INSTALL_COMPONENT=unwind
            -DCMAKE_INSTALL_DO_STRIP=1
            -P "${LIBUNWIND_BINARY_DIR}/cmake_install.cmake")
endif()

=== system/lib/wasmfs/fuzzer/Makefile ===
EMCC = ../../../../emcc
SOURCES = fuzzer.cpp random.cpp workload.cpp support/command-line.cpp

# Build with WasmFS enabled and pthreads.
EMFLAGS = -s WASMFS -s PROXY_TO_PTHREAD -s USE_PTHREADS -s ALLOW_MEMORY_GROWTH=1 -Werror -Wno-pthreads-mem-growth -I. --profiling-funcs 
CFLAGS = -std=c++17

.PHONY: build
build: $(SOURCES)
	$(EMCC) $(SOURCES) -o fuzzer.js $(EMFLAGS) $(CFLAGS)

# Build with debugging info.
.PHONY: debug
debug: $(SOURCES)
	$(EMCC) $(SOURCES) -o fuzzer.js $(EMFLAGS) -D FUZZER_DEBUG $(CFLAGS)

.PHONY: clean
clean:
	rm *.js *wasm

=== tests/third_party/openjpeg/codec/CMakeLists.txt ===
  # Build the demo app, small examples

# First thing define the common source:
SET(common_SRCS
  convert.c
  index.c
  ${OPENJPEG_SOURCE_DIR}/common/color.c
)

if (NOT CMAKE_HAVE_GETOPT_H)
  SET(common_SRCS ${common_SRCS} ${OPENJPEG_SOURCE_DIR}/common/getopt.c)
endif()

# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${LCMS_INCLUDE_DIR}
  ${OPENJPEG_SOURCE_DIR}/common
  )
IF(PNG_FOUND)
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
ENDIF(PNG_FOUND)
IF(TIFF_FOUND)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(WIN32)
  IF(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_EXPORTS)
  ELSE(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_STATIC)
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(WIN32)

# Loop over all executables:
FOREACH(exe j2k_to_image image_to_j2k j2k_dump)
  ADD_EXECUTABLE(${exe} ${exe}.c ${common_SRCS})
  TARGET_LINK_LIBRARIES(${exe} ${OPENJPEG_LIBRARY_NAME} ${LCMS_LIB})
  IF(PNG_FOUND)
    TARGET_LINK_LIBRARIES(${exe} ${PNG_LIBRARIES})
  ENDIF(PNG_FOUND)
  IF(TIFF_FOUND)
    TARGET_LINK_LIBRARIES(${exe} ${TIFF_LIBRARIES})
  ENDIF(TIFF_FOUND)
  ADD_TEST(${exe} ${EXECUTABLE_OUTPUT_PATH}/${exe})
  # calling those exe without option will make them fail always:
  SET_TESTS_PROPERTIES(${exe} PROPERTIES WILL_FAIL TRUE)
  # On unix you need to link to the math library:
  IF(UNIX)
    TARGET_LINK_LIBRARIES(${exe} m)
  ENDIF(UNIX)
  # Install exe
  INSTALL(TARGETS ${exe}
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  )
ENDFOREACH(exe)

# Install man pages
INSTALL(
  FILES       ../doc/man/man1/image_to_j2k.1
              ../doc/man/man1/j2k_dump.1
              ../doc/man/man1/j2k_to_image.1
  DESTINATION ${OPENJPEG_INSTALL_MAN_DIR}/man1)
#

if(BUILD_TESTING)
# Do testing here, once we know the examples are being built:
FILE(GLOB_RECURSE OPENJPEG_DATA_IMAGES_GLOB
  "${JPEG2000_CONFORMANCE_DATA_ROOT}/*.j2k"
  "${JPEG2000_CONFORMANCE_DATA_ROOT}/*.j2c"
  "${JPEG2000_CONFORMANCE_DATA_ROOT}/*.jp2"
  )

foreach(filename ${OPENJPEG_DATA_IMAGES_GLOB})
  get_filename_component(filename_temp ${filename} NAME)
  get_filename_component(filename_ext ${filename} EXT)
  execute_process(COMMAND ${EXECUTABLE_OUTPUT_PATH}/j2k_dump -i ${filename}
    OUTPUT_VARIABLE dump_success
    OUTPUT_FILE ${CMAKE_CURRENT_BINARY_DIR}/${filename_temp}.dump
    ERROR_QUIET
  )
  if(dump_success)
  file(READ ${CMAKE_CURRENT_BINARY_DIR}/${filename_temp}.dump numcomp_file)
  string(REGEX REPLACE ".*numcomps=([0-9]+).*" "\\1"
    numcomps "${numcomp_file}")
  #message( "found:${output_variable} for ${filename_temp}" )
  endif()
  ADD_TEST(dump-${filename_temp} ${EXECUTABLE_OUTPUT_PATH}/j2k_dump -i ${filename})
  foreach(codec_type ppm pgx bmp tif raw tga png)
    ADD_TEST(j2i-${filename_temp}-${codec_type} ${EXECUTABLE_OUTPUT_PATH}/j2k_to_image -i ${filename} -o ${filename_temp}.${codec_type})
    ADD_TEST(i2j-${filename_temp}-${codec_type} ${EXECUTABLE_OUTPUT_PATH}/image_to_j2k -i ${filename_temp}.${codec_type} -o ${filename_temp}.${codec_type}${filename_ext})
    #if(UNIX)
    #  ADD_TEST(cmp-${filename_temp}-${codec_type} cmp ${filename} ${filename_temp}.${codec_type}${filename_ext})
    #endif(UNIX)
  endforeach(codec_type)
endforeach(filename)
endif(BUILD_TESTING)

=== debian/changelog ===
emscripten (3.1.5~dfsg-3ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Feb 2022 21:59:26 +0100

emscripten (3.1.5~dfsg-3) unstable; urgency=medium

  * extend patch 1007
    to skip failing test other.test_closure_type_annotations;
    unfuzz patches
  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 21:41:57 +0100

emscripten (3.1.5~dfsg-2) experimental; urgency=medium

  * fix add another patch to avoid SjLj;
    unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 14:22:41 +0100

emscripten (3.1.5~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update source-only part of upstream source-map script
  * add another patch to avoid SjLj
  * unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 12:20:22 +0100

emscripten (3.1.4~dfsg-7ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 17 Feb 2022 20:40:22 +0100

emscripten (3.1.4~dfsg-7) unstable; urgency=medium

  * fix autopkgtest

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 17 Feb 2022 13:00:38 +0100

emscripten (3.1.4~dfsg-6) unstable; urgency=medium

  * update testsuite coverage
  * add patch 2014 to avoid root bypass of frozen cache

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Feb 2022 21:46:17 +0100

emscripten (3.1.4~dfsg-5) experimental; urgency=medium

  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Feb 2022 15:57:12 +0100

emscripten (3.1.4~dfsg-4) experimental; urgency=medium

  * fix install cache frozen
  * update patch 2013: fix syntax for resolving wasm2c
  * avoid installing cache sanity hint

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Feb 2022 11:58:37 +0100

emscripten (3.1.4~dfsg-3) experimental; urgency=medium

  * add more patches to avoid SjLj;
    add section about Wasm SjLj support to README.Debian

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 15 Feb 2022 23:24:26 +0100

emscripten (3.1.4~dfsg-2) experimental; urgency=medium

  * add patches to avoid SjLj using Wasm EH instructions
  * extend patch 1007
    to skip failing test other.test_closure_webgpu
  * unfuzz patches
  * install system-shared emscripten config file,
    to not have it generated (and fail) initial call
    to any emscripten tool
  * build and install cache of non-port libraries;
    drop section about code cache from README.Debian
  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 15 Feb 2022 20:15:45 +0100

emscripten (3.1.4~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * unfuzz patches
  * generate html and plaintext documentation from upstream markdown;
    build-depend on cmark-gfm
  * update source-only part of upstream source-map script

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 15 Feb 2022 10:34:03 +0100

emscripten (3.1.3~dfsg-5ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Feb 2022 09:26:31 +0100

emscripten (3.1.3~dfsg-5) unstable; urgency=medium

  * improve support for closure-compiler:
    + update patch 2009 to only fake version check,
      which is broken in old closure-compiler in Debian
      (i.e. drop broken changes to internal default)
    + extend patch 2011
      to use system-shared closure-compiler by default
    + update README.Debian
      with expected error message for too old closure-compiler
    closes bug#1005294, thanks to Jeremy James
  * avoid ccache (really not supported):
    + drop patch 2014
    + adjust build rules

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 11 Feb 2022 16:39:34 +0100

emscripten (3.1.3~dfsg-4ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Feb 2022 12:31:27 +0100

emscripten (3.1.3~dfsg-4) unstable; urgency=medium

  * fix avoid tests test_sdl2_config test_sdl2_ttf
    requiring download of Emscripten port;
    closes: bug#1004953, thanks to Gianfranco Costamagna

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 04 Feb 2022 11:11:18 +0100

emscripten (3.1.3~dfsg-3ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests
    - Ignore also test_sdl2_ttf, trying to reach github
      (Closes: #1004953)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Feb 2022 10:59:39 +0100

emscripten (3.1.3~dfsg-3) unstable; urgency=medium

  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Feb 2022 15:30:44 +0100

emscripten (3.1.3~dfsg-2) unstable; urgency=medium

  * update and tighten lintian overrides
  * update testsuite coverage
  * update TODOs

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Feb 2022 12:02:22 +0100

emscripten (3.1.3~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file:
    + ignore version of embedded type definitions,
      to not confuse tracker.debian.org
      (bug#1000969 fixed but website still failing)
  * unfuzz patches
  * update source-only part of upstream source-map script

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Feb 2022 01:22:19 +0100

emscripten (3.1.2~dfsg+~1.39.6-6ubuntu1) jammy; urgency=medium



=== debian/control ===
--- 
+++ 
@@ -5,30 +5,34 @@
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
- binaryen (>= 99) <!nocheck>,
- clang (>= 1:11.0) <!nocheck>,
+ binaryen (<< 105+) <!nocheck>,
+ binaryen (>= 105) <!nocheck>,
+ clang-13 <!nocheck>,
  cmake <!nocheck>,
+ cmark-gfm <!nodoc>,
+ debhelper-compat (= 13),
+ dh-sequence-python3,
  eslint <!nocheck>,
  fonts-liberation <!nocheck>,
- libsimde-dev,
- lld (>= 1:11.0) <!nocheck>,
- llvm (>= 1:11.0) <!nocheck>,
- debhelper-compat (= 13),
- dh-sequence-python3,
  help2man,
  htmlmin <!nocheck>,
+ jq,
  libjs-source-map,
+ libsimde-dev,
+ lld-13 <!nocheck>,
+ llvm-13 <!nocheck>,
  node-acorn <!nocheck>,
- nodejs <!nocheck>,
+ node-source-map <!nocheck>,
+ nodejs (>= 12.16) <!nocheck>,
  python3,
  python3-numpy <!nocheck>,
  python3-ply <!nocheck>,
  scons <!nocheck>,
- wabt <!nocheck>,
+ wabt (>= 1.0.24-2~) <!nocheck>,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc <!nocheck>,
  python3-sphinx <!nodoc>,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: http://emscripten.org/
 Vcs-Browser: https://salsa.debian.org/js-team/emscripten
 Vcs-Git: https://salsa.debian.org/js-team/emscripten.git
@@ -37,12 +41,13 @@
 Package: emscripten
 Architecture: all
 Depends:
- binaryen (>= 99),
- clang (>= 1:11.0),
- lld (>= 1:11.0),
- llvm (>= 1:11.0),
+ binaryen (<< 105+),
+ binaryen (>= 105),
+ clang-13,
+ lld-13,
+ llvm-13,
  node-acorn,
- nodejs,
+ nodejs (>= 12),
  ${misc:Depends},
  ${python3:Depends},
 Recommends:
@@ -53,10 +58,13 @@
  automake,
  closure-compiler,
  cmake,
+ emscripten-doc,
  make,
  python3-ply,
  scons,
- wabt,
+ wabt (>= 1.0.24-2~),
+Provides:
+ node-types-emscripten (= ${types:Version}),
 Description: LLVM-to-JavaScript Compiler
  Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
  called LLVM IR (which can be generated from C/C++ using Clang, or any other
@@ -69,7 +77,7 @@
      to JavaScript and interpreting code in that on the web
  .
  Some uses of emscripten require additional packages:
-  * setting WASM2C requires wabt.
+  * setting WASM2C requires wabt (at least release 1.0.24-2).
   * emcmake requires cmake.
   * emconfigure may require automake.
   * emmake requires make.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION_UPSTREAM DEB_DISTRIBUTION
include /usr/share/dpkg/pkg-info.mk

# resolve DEB_BUILD_OPTION_PARALLEL
-include /usr/share/dpkg/buildopts.mk

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

DEB_VERSION_UPSTREAM_ORIG = $(firstword $(subst ~,$() ,$(DEB_VERSION_UPSTREAM)))

DOCS_SRC = README.md
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DOCS = $(DOCS_SRC:md=html) $(DOCS_SRC:md=txt)
CHANGELOGS = ChangeLog.html ChangeLog.txt
endif

_ENV = $(strip \
 PATH="$(CURDIR)/debian/tmpbin:$$PATH" \
 EM_CACHE="$(CURDIR)/debian/em_cache")

# generate manpage with help2man from --help option of python script
_mkman = $(_ENV) \
 help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
 || { $(_ENV) $1 --help; false; }
_mkman_sloppy = $(_ENV) \
 help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
 || true

ifneq (,$(DEB_BUILD_OPTION_PARALLEL))
export EMCC_CORES=$(DEB_BUILD_OPTION_PARALLEL)
endif

EMCC = $(_ENV) emcc
TESTS_RUNNER = $(_ENV) EMTEST_LACKS_CLOSURE_COMPILER=1 EMTEST_SKIP_V8=1 tests/runner.py --skip-slow

# files generated during build
SOURCE_MAP_MIN_JS = src/emscripten-source-map.min.js
NEON_H = system/include/compat/arm_neon.h

# libraries available for compilation (ports are unavailable)
LIBS_ALL = $(shell $(_ENV) embuilder --em-config .emscripten --help \
 | grep -Po '^        \K\S+')
LIBSTEMS_PORTS = $(shell find tools/ports -maxdepth 1 -type f \
 | grep -Po 'tools/ports/\K[a-z]+' | sort -u)
LIBS_MAIN = $(filter-out $(addsuffix %,$(LIBSTEMS_PORTS)),$(LIBS_ALL))

# requires third-party tests
#  * test_freetype also requires symlinked LiberationSansBold.ttf
#  * test_poppler also requires tests.poppler.paper.pdf
ERRORS_core += \
 test_freetype \
 test_lua \
 test_openjpeg \
 test_poppler

# requires Emscripten Ports
ERRORS_other += \
 test_cmake_install \
 test_cmake_pthreads \
 test_cmake_with_embind_cpp11_mode \
 test_boost_graph \
 test_bullet \
 test_bullet_autoconf \
 test_bullet_cmake \
 test_bzip2 \
 test_cmake_find_sdl2 \
 test_cmake_find_stuff \
 test_cmake_html \
 test_deps_info \
 test_freetype \
 test_giflib \
 test_libjpeg \
 test_libpng \
 test_sdl2_config \
 test_sdl2_gfx_linkable \
 test_sdl2_linkable \
 test_sdl2_mixer_wav \
 test_sdl2_ttf \
 test_vorbis

# attempts to download files from a remote server
ERRORS_other += \
 test_icu \
 test_pthread_icu

# avoid unimportant mode causing multiple failures: strict
CHECK_MODES_coreX = core0 core1 core2 core3 cores corez
CHECK_MODES_coreZ = corez wasm2jsz
CHECK_MODES_core23Z = core2 core3 corez
CHECK_MODES_coreJS = wasm2js1 wasm2js2 wasm2js3 wasm2jss wasm2jsz
CHECK_MODES_coreJS1S = wasm2js1 wasm2jss

# expects smaller output
FAILS_core1 += \
 test_emscripten_lazy_load_code_unconditional
FAILS_other += \
 test_function_exports_are_small \
 test_js_function_names_are_minified \
 test_metadce_minimal_pthreads \
 test_minimal_runtime_code_size_*

# needs node module wasm2c
FAILS_other += \
 test_wasm2c_multi_lib \

# requires bugfix for Error: FS error
FAILS_core += \
 test_fs_nodefs_home

# unreliable; sometimes fails with AssertionError: Expected to find ... pthread sent an error! undefined:undefined: Aborted().
FAILS_core += \
 test_pthread_abort \

# requires newer LLVM: <https://github.com/emscripten-core/emscripten/issues/13773>
FAILS_core += \
 test_dylink_weak

# likely requires newer LLVM
ERRORS_core += \
 test_dylink_syslibs_missing_assertions
FAILS_core += \
 test_relaxed_simd_implies_simd128
FAILS_other += \
 test_lld_report_undefined_exceptions

# requires newer LLVM: see <https://reviews.llvm.org/D108877> and git commit 06dcec6
FAILS_core += \
 test_pthread_dylink_tls \
 test_dylink_tls_export

# unknown cause
FAILS_core1 += \
 test_dylink_dso_needed
FAILS_coreX += \
 test_dlfcn_self \
 test_pthread_exit_process \
 test_pthread_proxying
FAILS_coreZ += \
 test_float_builtins
FAILS_other += \
 test_cmake_stdproperty \
 test_embind_finalization \
 test_ld_library_path \
 test_metadce_hello_main_module_2 \
 test_minimal_dynamic \
 test_split_main_module

BIN_WRAPPER_SYMLINK = \
 em++ \
 emar \
 embuilder \
 emcc \
 emcmake \
 em-config \
 emconfigure \
 emmake \
 emranlib \
 emrun \
 emscons \
 emsize

BIN_WRAPPER_TOOLS_SYMLINK = \
 emdump \
 emdwp \
 emnm \
 emprofile \

NONSCRIPT_EXECUTABLE = \
 system/lib/libcxx/readme.txt \
 tests/other/wasm_sourcemap/foo.wasm \
 tests/other/wasm_sourcemap_dead/t.wasm \
 tools/system_libs.py

SCRIPT_NOT_EXECUTABLE = \
 src/compiler.js \
 tests/embind/build_benchmark \
 tests/sourcemap2json.js \
 tools/preprocessor.js \
 tools/run_python_compiler.sh

override_dh_clean:
	dh_clean -- $(DOCS) $(CHANGELOGS)

override_dh_auto_configure: $(SOURCE_MAP_MIN_JS) $(NEON_H)
# refresh upstream version hints from Debian package
	cp -f emscripten-version.txt emscripten-version.txt.orig
	echo $(DEB_VERSION_UPSTREAM_ORIG) > emscripten-version.txt
	echo $(patsubst $(DEB_VERSION_UPSTREAM_ORIG)-%,%,$(DEB_VERSION_UPSTREAM_ORIG_REVISION)) \
		> emscripten-revision.txt
	tools/create_dom_pk_codes.py
	mkdir -p debian/em_cache
# setup binaries for use during build-time testing
	mkdir --parents debian/tmpbin
	sed "s,/usr/share/emscripten/,$$PWD/," < debian/bin/wrapper > debian/tmpbin/wrapper
	sed "s,/usr/share/emscripten/,$$PWD/," < debian/bin/wrapper-tools > debian/tmpbin/wrapper-tools
	chmod +x debian/tmpbin/wrapper debian/tmpbin/wrapper-tools
	$(foreach symlink,$(BIN_WRAPPER_SYMLINK),ln -fsT wrapper debian/tmpbin/$(symlink);)
	$(foreach symlink,$(BIN_WRAPPER_TOOLS_SYMLINK),ln -fsT wrapper-tools debian/tmpbin/$(symlink);)

execute_before_dh_auto_build:
	$(EMCC) -v 2>&1

# build frozen cache of non-port libraries unless noopt requested
override_dh_auto_build:
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	$(_ENV) embuilder build $(LIBS_MAIN)
	$(_ENV) embuilder build $(LIBS_MAIN) --lto
	$(_ENV) embuilder build $(LIBS_MAIN) --pic
	$(_ENV) embuilder build $(LIBS_MAIN) --pic --lto
endif
	perl -p \
		-e "s/^# FROZEN_CACHE/FROZEN_CACHE/;" \
		-e "s,^EMSCRIPTEN_ROOT = '\K[^']+,/usr/share/emscripten,;" \
		.emscripten > debian/.emscripten

execute_after_dh_auto_build-arch: $(DOCS) $(CHANGELOGS)

# build documentation unless nodoc requested
execute_after_dh_auto_build-indep: $(DOCS) $(CHANGELOGS)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	sphinx-build -b html site/source debian/doc/html
endif

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(EMCC) tests/hello_world.c
	eslint --no-eslintrc --quiet --env browser --parser-options=ecmaVersion:6 --format unix a.out.js
	$(EMCC) -O3 tests/hello_world.c
	eslint --no-eslintrc --quiet --env browser --parser-options=ecmaVersion:6 --format unix a.out.js
	rm a.out.js a.out.wasm
	ln -sT /usr/share/fonts/truetype/liberation/LiberationSans-Bold.ttf \
		tests/freetype/LiberationSansBold.ttf
	$(TESTS_RUNNER) test_zlib_configure test_zlib_cmake
	$(TESTS_RUNNER) \
		$(CHECK_MODES_coreX) $(CHECK_MODES_coreJS) \
		$(addprefix skip:core*.,$(ERRORS_core) $(FAILS_core)) \
		$(addprefix skip:wasm*.,$(ERRORS_core) $(FAILS_core)) \
		$(addprefix skip:core1.,$(FAILS_core1)) \
		$(addprefix skip:core2.,$(FAILS_core2)) \
		$(foreach mode,$(CHECK_MODES_coreX),\
			$(addprefix skip:$(mode).,$(FAILS_coreX))) \
		$(foreach mode,$(CHECK_MODES_coreZ),\
			$(addprefix skip:$(mode).,$(FAILS_coreZ))) \
		$(foreach mode,$(CHECK_MODES_core23Z),\
			$(addprefix skip:$(mode).,$(FAILS_core23Z))) \
		$(foreach mode,$(CHECK_MODES_coreJS),\
			$(addprefix skip:$(mode).,$(FAILS_coreJS))) \
		$(foreach mode,$(CHECK_MODES_coreJS1S),\
			$(addprefix skip:$(mode).,$(FAILS_coreJS1S))) \
		$(if $(EXP_RELEASE),|| true)
	$(TESTS_RUNNER) other \
		$(addprefix skip:other.,$(ERRORS_other) $(FAILS_other)) \
		$(if $(EXP_RELEASE),|| true)
ifneq (,$(EXP_RELEASE))
	$(TESTS_RUNNER) \
		$(addprefix core1.,$(FAILS_core1)) \
		$(addprefix core2.,$(FAILS_core2)) \
